︠84e65148-262f-4378-aaa0-37dca44e1be8︠
# Mini project: Geometric median
# Your are a postmaster for a district in some state. There are n towns along a straight road. Let x[j], j=0..n-1,be the locations of the towns along the road. Your job is to determine the best location for a new post office; it should be located in one of the towns. Assume that the best location is the one that minimizes the average distance between the post office and the towns.

#Follow the plan in Lecture 6 or design your own plan. Enumerate the steps of your solution.


︡e8481ebe-6d13-41c6-a8a1-53736b2a8814︡
︠b4fb7202-1a99-442f-9e52-10d346f0ce0b︠
#Template for Step 2.Plotting the objective function (the sum of the distances to the post office) is similar to Exercise 4 in the problem set for this chapter.
def sum_of_dist(L):
    n=len(L)
    intervals=[(x,L[j],L[j+1]) for j in range(?)]
    G=Graphics()
    #Make and plot linear pieces using the formula for objective function
    for k in range(1,n):
        piece=(?)*x+sum(L[j] for j in range(?,?))-sum(L[j] for j in range(?))
        piece_plot=plot(?,intervals[k-1],thickness=2)
        G+=piece_plot
    G.show(figsize=[4,3])
S=[1,3,6,7,8,10];sum_of_dist(S)
︡c969d93f-ed8e-4794-a5d9-7ea69fc0cf19︡{"file":{"filename":"/home/user/.sage/temp/project-c2e46271-e550-4aa2-9e76-891fcc7c29eb/45816/tmp_1qwW5S.svg","show":true,"text":null,"uuid":"507dd002-3f70-4995-a6b8-c56c09f0e6f7"},"once":false}︡{"done":true}
︠69cc89bc-0887-4383-afe8-b95fc407b2e0︠

︡e8021c67-4a9a-43e2-8e05-6e0fb1438dcb︡
︠f87886bc-05a5-4b77-9bee-9823a19fac43︠
#############################
# Mini project: Analysis of a function f(x)=x/(x+1)-cos(40/x) with many characteristic features
#Step 1 (manual)
#Domain= # Complete the line
# lim_(x->infinity)=0; lim_(x->-infinity)=0
︡03d74f21-8dcf-4ce4-9418-453f1e67feae︡
︠a8db6e68-4cdb-4aa3-8c11-7837dc503442s︠
#Step 2:Plot the function
f(x)=x/(x+1)-cos(40/x)
p = plot(f(x),-2,2, ymin=-10, ymax=10 ); p.show(figsize=[5,4])
︡93dd3c27-d5f9-4566-9b0e-a8ac68ad3ffe︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/858/tmp_M6IavJ.svg","show":true,"text":null,"uuid":"a9852ad6-fa92-4508-b267-fbd44fd097a6"},"once":false}︡{"done":true}
︠748a7fc7-2193-48d3-b3e1-bbabc257bdf8s︠
#Step 3. Find the smallest negative and the largest positive x-intercepts for this function. (Note that the large intercept is REALLY large)
p_neg=plot(f(x),-.48,-.47);p_neg.show(figsize=[5,3],ymin=-1, ymax=.5)
find_root(f(x),-.48,-.47)

︡73065e1f-d74c-49df-b39c-bee0f01e5e3c︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/858/tmp_4Tnp8c.svg","show":true,"text":null,"uuid":"e40fd449-ce15-4feb-be23-d4a082c0da74"},"once":false}︡{"stdout":"-0.4740729100063728\n"}︡{"done":true}
︠f8b3fe8d-2c2d-46fd-b4d9-dce860a2e126r︠
#The large positive 
p_neg=plot(f(x),800,850);p_neg.show(figsize=[5,3],)
find_root(f(x),800,850)

︡298fbf52-d165-44f0-8dcc-6d2d1b44ef6e︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/944/tmp_RaUq_M.svg","show":true,"text":null,"uuid":"1cda36c2-6c3d-4649-a9c4-c54fce2e0820"},"once":false}︡{"stdout":"800.83244633264\n"}
︠0cee6cb2-69ca-4c8d-972b-06b612713412︠
#Step 4 (read Lecture 4, answer the question on Step 4)
# NO BECAUSE THERE ARE MANY SOLUTIONS.
︡da24e0e8-f229-4614-9bb6-5d3c828b4235︡
︠834567b9-ecea-498a-8e4e-f20a445cc994︠

︡ef08af86-fd88-4e9b-b30e-b948c0789cd7︡
︠bc37779f-be12-431e-ba9d-44e5df05a04cs︠
plot(f(x),-1.5,-1.05)
︡b5212f85-28c5-43d4-abce-c35a16f80f0b︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/858/tmp_AwurQT.svg","show":true,"text":null,"uuid":"81b30aff-31e9-4aa9-881c-ecedf3f9de3e"},"once":false}︡{"done":true}
︠4f93634a-357e-4175-a024-1e6b1ea2115ds︠
#Step 5. Find the largest local minimum on the interval (-infinity,-1).
deriv_plot=plot(derivative(f(x),x),-1.35,-1);deriv_plot.show(figsize=[5,4],ymin=-25,ymax=55)
find_root(derivative(f(x),x),-1.35,-1.)

#plot(derivative(f(x),x),-1.5,-1.1)
print "largest local minimum"
︡913f7ca4-d1c5-4cc1-b349-5e7de157a3b9︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/858/tmp_nvwosK.svg","show":true,"text":null,"uuid":"0ba3dafd-0545-409f-856d-1c363a9cb964"},"once":false}︡{"stdout":"-1.294057347382484\n"}︡{"stdout":"largest local minimum\n"}︡{"done":true}
︠f7d3bd21-b13e-4956-acd2-7908a5a09850︠

︡f4255b1c-d98e-4275-ab1f-1f37aa5fd028︡
︠e5b7c9f8-3bac-41a3-856a-faf1f36a4384︠

︡9164eb17-c67d-4cc2-83ae-0b5a73b58893︡
︠1ce23795-f579-4980-b522-d0e0a2aff30es︠
︡2e132da6-4e8f-4047-87c6-086b7d3fd620︡{"done":true}
︠9e1154fc-2d1b-4537-9bd8-d9ecb423bcf8︠









